import { ChatModel } from '../../model/chatModel';
// import axios = require('axios');
import '../../../css/styles.css';
import * as moment from 'moment';
import {DATE_FORMAT} from '../../model/constants';
let flowdockConfig = require('../../config/flowdockconfig.ts');

class ChatFactory {
    public static createModel(product , portfolio): Array<IChatModel> {

        let userMap = { };
        let chats = new Array<IChatModel>();
        let chat = new ChatModel('Project (10096)', product, portfolio);
        chat.participants = [];

        fetch(flowdockConfig.flowUrl + '/' + flowdockConfig.orgName +
            '/' + flowdockConfig.flowName + '/users' , {
            headers: flowdockConfig.apiHeaders ,
            method: 'GET' })
            .then(response => {
            return response.json();
        }).then(data => {
            data.map(function(user){
                userMap[user.id] = user.name;
            });
        }).then(response => {

        fetch (flowdockConfig.flowUrl + '/' + flowdockConfig.orgName + '/' +
        flowdockConfig.flowName + '/messages?tags=' + product + '_' + portfolio, {
            headers: flowdockConfig.apiHeaders ,
            method: 'GET' }).then (response => {
            return response.json();
        }).then (data => {
            data.map(function (userData) {
                    if (userData.event === 'message') {
                        let userid = userData.user;
                        chat.getMessage(userData.content, userMap[userid],
                            moment(userData.created_at).format(DATE_FORMAT), userData.id,
                            userData.tags.map((tag) => {
                                if (tag.toString().includes(':user:')) {
                                    let user = tag.split(':');
                                    let username = userMap[user[2]];
                                    return '@' + username;
                                } else if (tag !== ':url') {
                                    return tag;
                                } else if (tag === ':url') {
                                    return '';
                                }
                            }), product + '_' + portfolio, '', '', '');

                        chat.participants.push(userMap[userid]);
                    } else if ( userData.event === 'file' ) {
                        let userid = userData.user;
                        chat.getMessage(userData.event, userMap[userid],
                            moment(userData.created_at).format(DATE_FORMAT), userData.id,
                            userData.tags.map((tag) => {
                                if (tag.toString().includes(':user:')) {
                                    let user = tag.split(':');
                                    let username = userMap[user[2]];
                                    return '@' + username;
                                } else if (tag === ':file' || tag === ':url') {
                                    return '';
                                } else if (tag !== ':url') {
                                    return tag;
                                }
                            }), product + '_' + portfolio, userData.content.path,
                            userData.content.file_name, userData.content.content_type );
                        chat.participants.push(userMap[userid]);
                    }
                }
            );
        }); });
        chats.push(chat);

        let chat2 = new ChatModel('Resource', '', '');
        chat2.participants = ['Vidya', 'Sindhura', 'Praveen', 'Shanker'];
        // chat2.addMessage('Hey guys!', chat2.participants[1]);
        // chat2.addMessage('What now!?!1', chat2.participants[3]);
        // chat2.addMessage('hhhnnnngggg!', chat2.participants[2]);
        chats.push(chat2);

        let chat3 = new ChatModel('Task', '', '');
        chat3.participants = ['Anonymous', 'Admin'];
        // chat3.addMessage('Going for a break!', 'You');
        // chat3.addMessage('Have fun!', chat3.participants[1]);
        chats.push(chat3);

        return chats;
    }
}

export { ChatFactory };
