import * as React from 'react';
import '../../../css/fdstyles.css';
import {ENTER_KEY} from '../../model/constants';
let flowdockConfig = require('../../config/flowdockconfig.ts');

class TagView extends React.Component<ITagProps, {}> {

    constructor (props) {
        super(props);
    }
    public updateTags(event: __React.KeyboardEvent): void {
      if (event.keyCode !== ENTER_KEY) {
        return;
      }
      event.preventDefault();

      let aa = document.getElementById('tags').innerHTML;
      let splits = aa.split(',');
      let mydata = {
        event: 'message',
        tags: splits};
      // Submit form via jQuery/AJAX
      fetch (flowdockConfig.flowUrl + '/' + flowdockConfig.orgName + '/' +
        flowdockConfig.flowName + '/messages/' + this.props.msgId, {
        body: JSON.stringify(mydata),
        headers: flowdockConfig.apiHeaders ,
        method: 'PUT' }).then (response => {
        return response.json();
      });
    }
    public render() {
        let tagList = '';
        this.props.tags.map((item, index) => {
           tagList = tagList + item + ',' ;
        });
        if (this.props.childVisible === true) {
            return (
                <div id="tag-box" className="tag-input n">
                    <ul className="autocompleter hidden">
                    </ul>
                    <div className="tokenist focused" contentEditable="plaintext-only" spellCheck="false"
                         onKeyDown={e => this.updateTags(e)}>

                        <div id="tags">
                          {tagList}
                        </div>
                        <span className="tokenist-space">
                        </span></div>
                </div>
            );
        } else {
            return ( <div></div> );
        }
    }
}

export {TagView}
