import {MessageModel} from './messageModel';

class ChatModel implements IChatModel {
    public name: string;
    public participants: Array<string>;
    public messages: Array<IMessageModel>;
    public productName: string;
    public portfolioName: string;

    constructor(name: string, productName: string, portfolioName: string) {
        this.name = name;
        this.messages = new Array<IMessageModel>();
        this.participants = new Array<string>();
        this.productName = productName;
        this.portfolioName = portfolioName;
    }

    public addMessage (text: string, author: string, time: string): void {
        this.messages.push(new MessageModel(text, author, time));
    }

    public getMessage (text: string, author: string, time: string, msgId: number,
                       tags: Array<string>, contextString: string, filePath: string,
                       fileName: string, fileContentType: string): void    {
        let msgModel = new MessageModel(text, author, time);
        msgModel.msgId = msgId;
        msgModel.tags = tags;
        msgModel.contextString = contextString;
        msgModel.filePath = filePath;
        msgModel.fileName = fileName;
        msgModel.fileContentType = fileContentType;
        this.messages.push(msgModel);
    }
}

export {ChatModel};
