interface IMessageModel {
    key?: number;
    author: string;
    message: string;
    time: string;
    msgId: number;
    tags: Array<string>;
    contextString: string;
    filePath: string;
    fileName: string;
    fileContentType: string;
}

interface IChatModel {
    name: string;
    participants: Array<string>;
    messages: Array<IMessageModel>;
    addMessage:(text: string, author: string, time: string) => void;
    productName: string;
    portfolioName: string;
}

interface IAppProps {
    chatCollection:Array<IChatModel>;
}

interface ITagProps{
    childVisible: boolean;
    showThread: boolean;
    msgId: number;
    tags: Array<string>;
}

interface IChatView {
    chatCollection: Array<IChatModel>;
    chatId?: string;
    onStateChange?:(chatId: string) => void;
}

interface IChatListing {
    key: number;
    name: string;
    participants: number;
    onSelect: (name: string) => void;
}

interface IAppState {
    chatId?: string;
    messages?: number;
}

interface IMessageView {
    key: number;
    message: IMessageModel
}
